/*

Das Projekt ist gestoppt: es gelingt nicht, die richtigen Bibliotheken einzubinden.

<Wire.h> macht PRobleme

die Library TEA5767 wurde zurckgebaut: Radiomodul erbt TEA5767; die Funktionen mssen ergnzt werden



 * Main.cpp
 *
 * ich mchte Wire.h auf Serielle Schnittstelle umleiten->ENABLE_TWI2SERIAL = 1
 * leider muss man die Wire.h und Wire.cpp (bzw. fr Produktion Wire2Serial.h ...) aus dem Projekt entfernen um kompilieren zu knnen
 *
 *
 * Created: 8/26/2013 9:24:58 AM
 *  Author: roland
 */
// Disable some warnings for the Arduino files

#ifndef ENABLE_TWI2SERIAL
#pragma message ("ENABLE_TWI = 0")
#include <Wire.h>
#else
#include "Wire2Serial.h"
#pragma message ("ENABLE_TWI = 1")
#endif

#include <Arduino.h>
#include <EEPROM.h>
#include "TimerOne.h"
#include "radiomodul.h"
#include "traceit.h"
#include "printf.h"


//// Radiomodul Radio;
uint8_t present_state = 0;
#define STATE_START 0
#define STATE_SEARCH 1
#define SEARCHSTATE_TIME 10
#define alle_x_sekunden 5

const int analogInPin = A0; // Analog input pin that the potentiometer is attached to

int sensorValue = 0; // value read from the pot
int keyTime = 0;

void reset() {
    Timer1.stop();
    present_state = STATE_START;
    Radio.activeSenderPlace = EEPROM.read(0);
	Radio.timeout = false; 
    TRACE(Radio.activeSenderPlace)
    if (Radio.activeSenderPlace <1 || Radio.activeSenderPlace>NR_OF_STATIONS) Radio.clearAllStations();
    Radio.setActiveStation(Radio.activeSenderPlace);
}

void searchTimeout_ISR() {
    present_state = STATE_START;
    Timer1.stop();
	Radio.timeout = true; 
}

void setup() {
	initprintf(); //XXXX
	pinMode(13,OUTPUT);
    Serial.begin (115200);
    Wire.begin(); //Pin 2 = SDA und 3 = SCL in twi.c umprogrammiert
    Radio.init();
    Timer1.initialize (alle_x_sekunden * 1000000);
    Timer1.attachInterrupt (searchTimeout_ISR, alle_x_sekunden * 1000000);
    reset();
}

//short Keystrokes = Keycode 1,2,3
//long Keystrokes = 11, 12, 13
//very long Keystrokes = 101, 102, 103

uint8_t waitForKey() {
    TRACE ("waitForKey")
    int newSensorValue = 0;
    DELAY (20); //let the adc recreate

    while (sensorValue == 0) {
        sensorValue = analogRead (analogInPin);
        DELAY (50) //debounce
    }

    //delay(50);  //let the adc settle
    sensorValue = analogRead (analogInPin);
    DELAY (300);
    newSensorValue = analogRead (analogInPin);

    while ( (newSensorValue / 100 == sensorValue / 100) && (sensorValue != 0) ) { // div by 100 to reduce sensibility
        DELAY (300)
        keyTime++;
        newSensorValue = analogRead (analogInPin);
    }

    int keyValue = map (sensorValue, 0, 1023, 0, 5);

    if (keyTime >= 2 && keyTime <= 6) keyValue += 10;
    else if (keyTime > 6) keyValue += 100;

    sensorValue = 0;
    keyTime = 0;
    return keyValue;
}


void errorMessage (uint8_t key) {
    TRACE ("Error Message")
}

void loop() {
    static int nr = 0;
    nr++;
    TRACE (nr)
    if (Radio.read_status(Radio.buf) == 1) {
            double current_freq = floor(Radio.frequency_available(Radio.buf) / 100000 + .5) / 10;
            int stereo = Radio.stereo(Radio.buf);
            int signal_level = Radio.signal_level(Radio.buf);
            TRACE(Radio.activeSenderPlace)
			TRACE(current_freq)
            TRACE(signal_level)
        }
    
    uint8_t key;
    key = waitForKey(); 
    //key = 13;
	Radio.timeout = false; 
    switch (key) {
    case 1:
        TRACE ("Key short down")
        if (present_state == STATE_SEARCH) { // short click means small up/down frequ. change
            Timer1.resume();
            Timer1.start();
            sei(); //restart Timeout
             Radio.decFrequency(Radio.buf);
        } else
             Radio.prevStation();

        break; //click key

    case 3:
        TRACE ("Key short up");

        if (present_state == STATE_SEARCH) { // short click means small up/down frequ. change
            Timer1.resume();
            Timer1.start();
            sei(); //restart Timeout
            Radio.incFrequency(Radio.buf);
        } else
                Radio.nextStation();
            break; //click key

    case 12:
    case 2:
        TRACE ("Key short double");
        reset();
        break;

    case 11:
        TRACE ("Key 11 Search next Station");
        present_state = STATE_SEARCH;
        Timer1.resume();
        Timer1.start();
        sei();
        Radio.searchNextStation();
        break; //short key pressure

    case 13:
        TRACE ("Key 13 Search prev Station");
        present_state = STATE_SEARCH;
        Timer1.resume();
        Timer1.start();
        sei();
        Radio.searchPrevStation();
        break;

    case 101:
        TRACE ("Key 101 Save Station");
        Radio.saveStationToEEPROM();
        break; //long Key pressure (ca 10s)

    case 102:
        TRACE ("Key 102 Clear all Stations");
            Radio.clearAllStations();
        reset();
        break; //long Key pressure (ca 10s)

    case 103:
        TRACE ("Key 103 Save Station");
        Radio.saveStationToEEPROM();
        break; //long Key pressure (ca 10s)

    default:
        errorMessage (key);
    }

    DELAY (500)
}



